#!/bin/bash

INPUTFILE=${1}
EXEC=${2}
DEVICE=${3}

NVPROFOUT=myNvProfOut

METRICSLIST="sm_efficiency ipc achieved_occupancy issued_ipc inst_per_warp inst_integer inst_bit_convert tex_cache_hit_rate tex_cache_throughput l2_texture_read_hit_rate l2_texture_read_throughput dram_read_throughput dram_write_throughput gst_requested_throughput gld_requested_throughput gst_throughput gld_throughput"

EVENTSLIST="branch divergent_branch"

FEEDSWAP=$(for N in ${METRICSLIST}
do 
    echo -n ${N},
done)

FEEDMETRICS=$(echo ${FEEDSWAP:$[0]:$[$((${#FEEDSWAP} - 1))]})

FEEDSWAP=$(for N in ${EVENTSLIST}
do 
    echo -n ${N},
done)

FEEDEVENTS=$(echo ${FEEDSWAP:$[0]:$[$((${#FEEDSWAP} - 1))]})

echo "The measured metrics are the following:"
echo ${FEEDMETRICS}

while read LINE
do

    LAUNCHVALUES=$(echo ${LINE} | awk '{print($1, $2, $3, $4);}')
    echo ${LAUNCHVALUES}
    nvprof --log-file ${NVPROFOUT} --devices ${DEVICE} --metrics ${FEEDMETRICS} --events ${FEEDEVENTS} ${EXEC} ${DEVICE} ${LAUNCHVALUES} 1 16

    for N in ${METRICSLIST} ${EVENTSLIST}
    do
	RESULTS=$(cat ${NVPROFOUT} | grep ${N} | awk '{print($(NF - 2), $(NF - 1), $NF);}' )
	echo ${LAUNCHVALUES} ${RESULTS} >> ${EXEC}_dev${DEVICE}_${N}
    done

done < ${INPUTFILE}
